package ddmsg

import (
	"fmt"
	"git.rosy.net.cn/jx-callback/business/jxutils/enterprise_msg"
	"git.rosy.net.cn/jx-callback/business/model/dao"

	"git.rosy.net.cn/baseapi/platformapi/dingdingapi"
	"git.rosy.net.cn/baseapi/utils/errlist"
	"git.rosy.net.cn/jx-callback/business/auth2"
	"git.rosy.net.cn/jx-callback/business/auth2/authprovider/dingding"
	"git.rosy.net.cn/jx-callback/globals"
	"git.rosy.net.cn/jx-callback/globals/api"
)

func SendDDUserMessage(msgType, ddUserID, title, content string) (err error) {
	if globals.IsProductEnv() {
		if msgType == dingdingapi.MsgTyeText {
			err = api.DingDingAPI.CorpAsyncSendSimple(ddUserID, content)
		} else if msgType == dingdingapi.MsgTypeMarkdown {
			err = api.DingDingAPI.CorpAsyncSendMarkdown([]string{ddUserID}, nil, false, title, content)
		}
	}
	return err
}

func SendUserMessage(msgType, userID, title, content string) (err error) {
	authList, err := auth2.GetUserBindAuthInfo(userID)
	findOneMethod := false
	if err == nil {
		for _, auth := range authList {
			if auth.Type == dingding.AuthTypeStaff /*|| auth.Type == weixin.AuthTypeMP*/ {
				findOneMethod = true
				if len(content) > dingdingapi.MaxWorkContentLen {
					content = content[:dingdingapi.MaxWorkContentLen-4] + "..."
				}
				if err := SendDDUserMessage(msgType, auth.AuthID, title, content); err != nil {
					userInfo, err := dao.GetUserByID(dao.GetDB(), "user_id", auth.UserID)
					if err != nil || userInfo == nil {
						globals.SugarLogger.Errorf("get user err %v", err)
						continue
					}
					enterprise_msg.SendUserMessage(*userInfo.Mobile, title, content, content)
				}
				break
			}
		}
	}
	if !findOneMethod {
		err = fmt.Errorf("用户[%s]找不到至少一个有效的通讯方式", userID)
	}
	if err != nil {
		globals.SugarLogger.Infof("SendUserMessage userID:%s, title:%s, content:%s failed with error:%v", userID, title, content, err)
	}

	return err
}

func SendUsersMessage(msgType string, userIDs []string, title, content string) (err error) {
	errList := errlist.New()
	for _, userID := range userIDs {
		errList.AddErr(SendUserMessage(msgType, userID, title, content))
	}
	err = errList.GetErrListAsOne()
	return err
}
